Package uk.ac.starlink.topcat

## Enum ResourceType

- java.lang.Object
- - java.lang.Enum<ResourceType>
  - - uk.ac.starlink.topcat.ResourceType

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Comparable<ResourceType>`

      public enum ResourceType
      extends java.lang.Enum<ResourceType>

  Defines different kinds of resources that can be at the end of a URL. This is used for the purposes of deciding what actions to invoke on it, for instance in the context of DataLink.
  Since:
    6 Feb 2018
  Author:
    Mark Taylor

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `DATALINK` | DataLink {links}-response table.
    `FITS_IMAGE` | FITS file to be interpreted as image data.
    `IMAGE` | Graphical image, typically not FITS (PNG, JPEG etc).
    `SPECTRUM` | Some kind of spectrum.
    `TABLE` | Table.
    `UNKNOWN` | Unknown resource type.
    `WEB` | Something that can be displayed in a web browser, for instance HTML.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static ResourceType` | `guessResourceType​(java.net.URL url, java.lang.String contentType, java.lang.String standardId)` | Attempts to determine the type of resource characterised by available information.
    `static ResourceType` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
    `static ResourceType[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### TABLE

          public static final ResourceType TABLE

      Table.

    - #### DATALINK

          public static final ResourceType DATALINK

      DataLink {links}-response table.

    - #### FITS_IMAGE

          public static final ResourceType FITS_IMAGE

      FITS file to be interpreted as image data.

    - #### SPECTRUM

          public static final ResourceType SPECTRUM

      Some kind of spectrum.

    - #### IMAGE

          public static final ResourceType IMAGE

      Graphical image, typically not FITS (PNG, JPEG etc).

    - #### WEB

          public static final ResourceType WEB

      Something that can be displayed in a web browser, for instance HTML.

    - #### UNKNOWN

          public static final ResourceType UNKNOWN

      Unknown resource type.

  - ### Method Detail

    - #### values

          public static ResourceType[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (ResourceType c : ResourceType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static ResourceType valueOf​(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### guessResourceType

          public static ResourceType guessResourceType​(java.net.URL url,
                                                       java.lang.String contentType,
                                                       java.lang.String standardId)

      Attempts to determine the type of resource characterised by available information. Works on a best-efforts basis.
      Parameters:
        `url` - resource URL
        `contentType` - known or inferred Content-Type string (RFC 2045), or null if not known
        `standardId` - known or inferred IVOA standard ID, or null if not known
      Returns:
        best guess at the type of resource corresponding to the given information